--- texutil.pl.81	2004-03-15 12:37:02.699383701 +0100
+++ texutil.pl	2004-03-15 12:40:01.039813613 +0100
@@ -40,7 +40,7 @@
 #D binary version, like scanning illustrations other than \EPS.
 #D I would suggest to keep an eye on the version number:
 
-$Program = "TeXUtil 8.1 - ConTeXt / PRAGMA ADE 1992-2003" ;
+$Program = "TeXUtil 8.1f - ConTeXt / PRAGMA ADE 1992-2003" ;
 
 #D By the way, this is my first \PERL\ script, which means
 #D that it will be improved as soon as I find new and/or more
@@ -2011,7 +2011,7 @@
         if ($FUni)
           { print "n=$FNam t=$FTyp " .
          (sprintf "x=%1.3fcm y=%1.3fcm ", $FXof, $FYof) .
-         (sprintf "w=%1.3fcm h=%1.3fcm\n", $FWid, $FHei) }
+         (sprintf "w=%5.3fcm h=%5.3fcm\n", $FWid, $FHei) }
         else
           { print "n=$FNam t=$FTyp " .
                   "x=${FXof}bp y=${FYof}bp " .
@@ -2245,9 +2245,9 @@
     return $N/$M }
 
 sub TifGetAscii
-  { my ($S) = "" ;
+  { my $S = "" ;
     --$TifValues;
-    if ($TifValues)
+    unless ($TifValues)
       { return "" }
     else
       { read TIF, $S, $TifValues ;
@@ -2333,8 +2333,10 @@
              while (TifGetChunk) { }
              if ($TifUnit==2)
                { $TifMult = $INtoCM }
-             else
+             elsif ($TifUnit==3)
                { $TifMult = 1 }
+             else
+               { $TifMult = 72 }
                  $TifWidth  = ($TifWidth /$TifHRes)*$TifMult ;
                  $TifHeight = ($TifHeight/$TifVRes)*$TifMult ;
                  close ( TIF ) ;
@@ -2384,14 +2386,14 @@
             $PngVRes = PngGetLong ;
             read PNG, $PngUnit, 1 }
         elsif ($PngType eq "tEXt")
-          { read PNG, $PngKeyword, 79 ;
-            read PNG, $PngDummy, 1 ;
+          { read PNG, $PngKeyword, $PngLength;
+            ($PngKeyword,$PngDummy) = split(/\x00/,$PngKeyword);
             if ( $PngKeyword eq "Title")
-              { read PNG, $PngTitle, $Length }
+              { $PngTitle  = $PngDummy }
             elsif ( $PngKeyword eq "Author")
-              { read PNG, $PngAuthor, $PngLength }
+              { $PngAuthor = $PngDummy }
             elsif ( $PngKeyword eq "Software")
-              { read PNG, $PngCreator, $PngLength } }
+              { $PngCreator = $PngDummy } }
         return 1 }
     else
       { return 0 } }
@@ -2511,6 +2513,8 @@
       { $JpgMult = $INtoCM }
     else
       { $JpgMult = 1 }
+    $JpgHRes = 72 unless $JpgHRes>1;
+    $JpgVRes = 72 unless $JpgVRes>1;
     $JpgWidth = ($JpgWidth/$JpgHRes)*$JpgMult ;
     $JpgHeight = ($JpgHeight/$JpgVRes)*$JpgMult ;
     close ( JPG ) ;
